"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
function getSchemaInfo(graphQLSchema) {
    var mutations = formatRootObjectType(graphQLSchema.getMutationType());
    var queries = formatRootObjectType(graphQLSchema.getQueryType());
    var subscriptions = formatRootObjectType(graphQLSchema.getSubscriptionType());
    return {
        queries: queries,
        mutations: mutations,
        subscriptions: subscriptions
    };
}
exports.getSchemaInfo = getSchemaInfo;
function formatRootObjectType(objectType) {
    if (!objectType
        || _.isUndefined(objectType)
        || _.isUndefined(objectType.getFields)) {
        return false;
    }
    return _.reduce(objectType.getFields(), function (sum, value, key) {
        var _a;
        return __assign(__assign({}, sum), (_a = {}, _a[key + ("(" + _.join(_.map(value.args, function (arg) {
            return arg.name;
        }), ", ") + ") => " + value.type.toString())] = value.description, _a));
    }, {});
}
//# sourceMappingURL=getSchemaInfo.js.map